Subject: RE: [Sip] Open Issue #281: Entire URI as a key to location servic e lookup

From: "Peterson, Jon" <[email-masked]>
Date: Thu, 6 Dec 2001 17:43:15 -0600

When a user agent registers, the location service uses the address of record
given in the To field of the registration as the key that it maps to the
various Contact addresses. An address of record should be as simple and
general-purpose a URI as possible, not speaking to any capabilities or
locations associated with the owner of the address; it should probably have
a 'user@domain' format (sip:[email-masked]) as opposed to a more
specific format incorporating hostnames, parameters and so forth. Then
ideally the location service would have some sort of logical table for each
such 'domain' value under its administration in which the 'user' values are
the actual keys. However, today we don't really provide any such guidelines
for creating addresses of record for registrations in rfc2543bis. I suspect
that if we did so we'd find this problem much easier.

If the format of addresses of record were determinate, we could describe
precisely how to transform more complex and specific URIs into addresses of
record. This would never be possible for some URIs (sip:10.100.0.1:5062) but
then again it isn't clear why these sorts of URIs would be offered as keys
to a location service (i.e. a lookup on that URI should result in a failure
anyway). The transformation would most likely involving stripping certain
parameters (including possibly SIP URI parameters, user (e.g. tel URL)
parameters, and ports) and perhaps simplifying the host portion of the URI
into a domain when applicable.

It sounds like what Igor is saying is that a location service must apply the
same transformation to URI keys whether it receives them as a result of
registrations (setting new key-value pairs) or requests (lookups on a key).
I think that definitely sounds right, and that it will increase the chances
of finding good matches in the location service. 

Beyond that, I also agree that we should attempt to standardize this
transformation at least for the purposes of making a recommendation, even if
we don't want to levy a mandate. I think this transformation could also be
useful for some other purposes related to identity management.

Jon Peterson
NeuStar, Inc.

> -----Original Message-----
> From: Jonathan Rosenberg [mailto:[email-masked]]
> Sent: Thursday, December 06, 2001 2:06 PM
> To: [email-masked]'
> Subject: [Sip] Open Issue #281: Entire URI as a key to 
> location service
> lookup
> 
> 
> Issue:
> 
> There are problems with the bis-05 text which says that a 
> proxy should use
> the 
> entire URL from the request URI as the key to lookup contacts in the
> location 
> service DB. The problem is that sometimes the R-URI has 
> transport and maddr 
> params, used for routing, and these are not part of the To 
> header in the 
> REGISTER, so a 404 is getting sent.
> 
> Igor Slepchin has proposed that the choice of key is a matter of local
> policy, so long 
> as its consistent between registration processing and request routing 
> processing. However, I think some guidelines would be helpful to avoid
> having 
> people shoot themselves in the foot. 
> 
> The text used to give no guidance on this, but we changed it 
> to say the
> entire 
> URL since there had been other problems, or so I recall. Not 
> sure what the 
> previous problems were, though.
> 
> Another issue with using the whole URL as input to the 
> location DB is that
> the key is no longer a simple string; this makes lookups more complex.
> 
> Proposal:
> 
> Allow key for LS lookups to be a matter of local policy. 
> Describe issues
> (like using port and maddr are bad).
> 
> -Jonathan R.
> 
> ---
> Jonathan D. Rosenberg, Ph.D.                72 Eagle Rock Ave.
> Chief Scientist                             First Floor
> dynamicsoft                                 East Hanover, NJ 07936
> [email-masked]                     FAX:   (973) 952-5050
> http://www.jdrosen.net                      PHONE: (973) 952-5000
> http://www.dynamicsoft.com
>  
> 
> _______________________________________________
> Sip mailing list  http://www1.ietf.org/mailman/listinfo/sip
> This list is for NEW development of the core SIP Protocol
> Use [email-masked] for questions on current sip
> Use [email-masked] for new developments on the application of sip
> 

_______________________________________________
Sip mailing list  http://www1.ietf.org/mailman/listinfo/sip
This list is for NEW development of the core SIP Protocol
Use [email-masked] for questions on current sip
Use [email-masked] for new developments on the application of sip

---

From: Jonathan Rosenberg <[email-masked]>
Date: Thu, 27 Dec 2001 00:35:01 -0500

There were two comments on this proposal, from Jo Hornsby and from Jon 
Peterson (enclosed below). Both support the proposal. Jon recommended 
some additional text on reasonable choices for the "transformation" as 
he describes it. I think thats OK; discussing the issue in particular 
with user=phone (whether or not that is part of the key, and I believe 
it generally is).

So, I will consider this issue closed.

Thanks,
Jonathan R.

-- 
Jonathan D. Rosenberg, Ph.D.            72 Eagle Rock Avenue
Chief Scientist                         First Floor
dynamicsoft                             East Hanover, NJ 07936
[email-masked]                 FAX: (973) 952-5050
http://www.jdrosen.net                  PH:  (973) 952-5000
http://www.dynamicsoft.com